# Class and method declaration errors
1. All programs must have a method main() with void return type in the class Main (`INVALID_START_POINT`)
2. The superclass of each class exists (`NO_SUCH_TYPE`)
3. There is no circular inheritance (`CIRCULAR_INHERITANCE`)
4. No class is declared with the name `Object` (`OBJECT_CLASS_DEFINED`)
5. Unique names (`DOUBLE_DECLARATION`) for each group:
    1. Class names
    2. Field names in a single class (field shadowing is allowed)
    3. Method names in a single class (Override is allowed, overloading not)
    4. Method parameters and local variable names
6. Overridden methods must: (`INVALID_OVERRIDE`)
    1. Have the same number of parameters
    2. The return types must match
    3. The type of the parameters must match (name can differ)

# Method body errors
1. `write()` must take one argument of type `int` (`TYPE_ERROR`)
2. `read()` and `writeln()` must take no arguments (`WRONG_NUMBER_OF_ARGUMENTS`)
3. The condition of a `while` or `if` statement must be typed `booelan` (`TYPE_ERROR`)
4. Assignments: the type of the right-hand side must be a suptype of the type of the left-hand side. (`TYPE_ERROR`)
5. Operators (`TYPE_ERROR`):
    1. `*`, `/`, `%`, `+`, `-`, `<`, `>`, `<=`, `>=` take `int` arguments only.
    2. `!`, `&&`, `||` take `boolean` arguments only.
    3. `==` and `!=` takes any couple of arguments as long as one of the types is a subtype of the other.
    4. A cast is only possible if one of the types is a subtype of the other
6. Method invocation, must match with declaration:
    1. The number of parameters (`WRONG_NUMBER_OF_ARGUMENTS`)
    2. The type of each of the parameters (`TYPE_ERROR`)
7. Arrays:
    1. When indexing, the index expression must be an `int` (`TYPE_ERROR`)
    2. When creating one, the index expression must be an `int` (`TYPE_ERROR`)
8. The constant `null` can be assigned to any reference type.
9. The type name in a `new` statement must exist (`NO_SUCH_TYPE`)
10. The left-hand side of an assignment can only be: (`NOT_ASSIGNABLE`)
    1. A variable
    2. A field
    3. Array dereferences (indexing)
11. There must be no attempt to access the field or method of a
non-object type, such as arrays or primitive types (`TYPE_ERROR`)
12. A method with a return type must have a return statement at the end
of all its paths (`MISSING_RETURN`). A while loop is not a valid return
regardless of the condition. A ifElse must have a return on both the
else and otherwise block. There may be some statements after a return.